/**
 * @version $Id: ROMDexmlTest.java 1140 2011-04-04 16:37:58Z yegor256@yahoo.com $
 */
package com.rempl.api;

import org.junit.*;
import static org.junit.Assert.*;
import java.util.*;
import javax.xml.parsers.*;
import javax.xml.xpath.*;
import org.w3c.dom.*;
import org.xml.sax.InputSource;
import java.io.*;

public class ROMDexmlTest {

    @Test
    public void testRetrievesAllBasicTypes() throws Exception {
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        DocumentBuilder builder = factory.newDocumentBuilder();
        String xml = "<root><foo><a>aaa</a><b>bbb</b></foo></root>";
        Document doc = builder.parse(new InputSource(new StringReader(xml)));
        XPathFactory xpathFactory = XPathFactory.newInstance();
        final XPath xpath = xpathFactory.newXPath();
        NodeList nodes = (NodeList) xpath.evaluate(
            "//foo/*",
            doc,
            XPathConstants.NODESET
        );
        List<String> list = (List<String>) new ROMDexml("abc").convert(nodes, String[].class);
        assertEquals(2, list.size());

        Map<String, String> map = (Map<String, String>) new ROMDexml("abc").convert(nodes, Map.class);
        assertEquals(2, map.size());
        assertTrue(map.containsKey("a"));
        assertEquals("aaa", map.get("a"));
    }

}
