/**
 * @version $Id: RuntimeProblemTest.java 392 2011-03-01 11:45:33Z yegor256@yahoo.com $
 */
package com.rempl.api;

import org.junit.*;
import static org.junit.Assert.*;

public class RuntimeProblemTest {

    @Test
    public void testValidatesExceptionClass() {
        String reason = "some reason";
        Throwable ex = RuntimeProblem.make(reason);
        assertTrue(ex instanceof RuntimeProblem);
        assertTrue(ex.getMessage().contains(reason));
    }

    @Test
    public void testValidatesExceptionClassViaThrowableCause() {
        String reason = "some reason";
        Throwable ex = RuntimeProblem.make(new RuntimeException(reason));
        assertTrue(ex instanceof RuntimeProblem);
        assertTrue(ex.getMessage().contains(reason));
    }

    @Test
    public void testValidatesExceptionClassViaThrowableCauseAndString() {
        String reason = "some reason";
        Throwable ex = RuntimeProblem.make(reason, new RuntimeException());
        assertTrue(ex instanceof RuntimeProblem);
        assertTrue(ex.getMessage().contains(reason));
    }

    @Test
    public void testValidatesExceptionClassViaVarargString() {
        Throwable ex = RuntimeProblem.make("number %d", 3);
        assertTrue(ex instanceof RuntimeProblem);
        assertEquals("number 3", ex.getMessage());
    }

}
