/**
 * @version $Id: DiagramTest.java 991 2011-03-29 13:06:14Z yegor256@yahoo.com $
 */
package com.rempl.api.uml;

import org.junit.*;
import static org.junit.Assert.*;
import com.rempl.api.Model;
import com.rempl.impl.ModelImpl;

public class DiagramTest {

    @Test
    public void testBuildsDiagram() throws Exception {
        Diagram diagram = new Diagram();
        diagram.add("Class").add("name", "Employee");
        String uml = diagram.uml();
        assertEquals("i0:Class{name:\"Employee\";};", uml);
    }

    @Test
    public void testComplexType() throws Exception {
        Diagram diagram = new Diagram();
        Instance instance = diagram.add("Class");
        instance.add("name", "Employee");
        instance.add(
            "stereotype",
            diagram.add("Stereotype")
                .add("name", "file")
        );
        String uml = diagram.uml();
        assertTrue(uml.contains("\"file\""));
    }

    @Test
    public void testTransformsModelWithDiagram() throws Exception {
        Diagram diagram = new Diagram();
        Instance comment = diagram.add("Comment")
            .add("value", "The \"comment\"");
        Instance cls = diagram.add("Class")
            .add("name", "Employee")
            .add("isAbstract", true)
            .add("comment", comment);
        String uml = diagram.uml();
        Model model = new ModelImpl();
        model.transform(uml);
    }

}
