/**
 * @version $Id: InstanceTest.java 1140 2011-04-04 16:37:58Z yegor256@yahoo.com $
 */
package com.rempl.api.uml;

import org.junit.*;
import static org.junit.Assert.*;
import com.rempl.api.Model;
import com.rempl.api.Element;
import com.rempl.impl.ModelImpl;
import java.util.Collection;

public class InstanceTest {

    @Test
    public void testBuildsComplexInstance() throws Exception {
        Diagram diagram = new Diagram();
        Instance i = diagram.add("Class")
            .add("name", "Employee")
            .add("parent", diagram.add("Class"))
            .add("parent", diagram.add("Class"));
        String uml = i.uml(diagram);
        System.out.println(uml);
        Model model = new ModelImpl();
        model.transform(uml);
        Collection<Element> elements = model.query("context Class inv: true");
        assertEquals(1, elements.size());
        for (Element e : elements) {
            assertEquals(2, e.all("parent").size());
        }
    }

    @Test(expected = IllegalArgumentException.class)
    public void testAttemptsToAddDuplicatedValue() throws Exception {
        Diagram diagram = new Diagram();
        Instance i = diagram.add("Class")
            .add("name", "Employee")
            .add("parent", "a1")
            .add("parent", "a2");
    }
}
